#!/bin/bash 

# Copyright (c) 2007-2008   Centrify Corp.
#
# Collect all necessary files for adinfo --support
# Store in /tmp/adinfo_support.tar and zipped or compressed.
#

#
# Parameter:
# $1 - path of the adinfo_support.txt

# Get the path of the adinfo_support.txt
SUPPORTFILE="$1"
SUPPORTDIR=`echo $SUPPORTFILE|sed 's/[^/]*$//g'`
DEST="${SUPPORTDIR}adinfo_support.tar"
SOURCE="/var/log/centrify_client.log /var/adm/syslog/centrify_client.log /etc/centrifydc /var/centrifydc/reg/machine/gp.report $SUPPORTFILE"

if [ -f $DEST ]; then
    echo "Remove previous $DEST"
    rm -f $DEST
fi
if [ -f $DEST.gz ]; then
    echo "Remove previous $DEST.gz"
    rm -f $DEST.gz
fi
if [ -f $DEST.Z ]; then
    echo "Remove previous $DEST.Z"
    rm -f $DEST.Z
fi

echo "Collecting information for adinfo --support now..."
tar -cf $DEST $SOURCE 2> /dev/null

if [ -f $DEST ]; then
    #Like adinfo_support.txt file, only Allow root read right too.
    chmod 400 $DEST
    
    echo "Collection finished. Compress now."
    gzip $DEST

    if [ $? -eq 0 ]; then
        echo "Successfully gzip $DEST."
    else
        echo "gzip failed, using compress instead."
        compress $DEST
        
        if [ $? -eq 0 ]; then
            echo "Successfully compress $DEST."
        else 
            echo "compress failed. Keep $DEST."
        fi
    fi
else
    echo "Collection faild!"
fi
